/**
 * This file is part of cs838-dc1

 * cs838-dc1 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs838-dc1 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs838-dc1.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef GENERALEXCEPTION_H
#define GENERALEXCEPTION_H

#include <sstream>
#include <exception>
#include <string>
using namespace std;

class GeneralException : exception
{
	public:
		GeneralException(const char * msg) : exception() { message = msg; };
		virtual ~GeneralException() throw() { };
	
		virtual const char * what() { return message.c_str(); };
	
	private:
		string message;
};

#define throwGen(msg,...) \
	do \
	{ \
		static char buffer[2048]; \
		static char message[2048]; \
		snprintf(buffer, 2048, "%s - %d : %s", __FILE__, __LINE__, msg); \
		snprintf(message, 2048, buffer, __VA_ARGS__); \
		throw GeneralException(message); \
	} while(false)
#endif // GENERALEXCEPTION_H
