/**
 * This file is part of cs838-dc1

 * cs838-dc1 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs838-dc1 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs838-dc1.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef BAR_DIFF_H
#define BAR_DIFF_H

#include "diff_widget.h"

#include <QString>
#include <QColor>

#include <vector>
using namespace std;

/**
 * a bar diff compares a number of frames using 
 * the height of a bar to make the comparison
 */
class BarDiff : public DiffWidget
{
	public:
		BarDiff(QWidget * parent = 0);
		virtual ~BarDiff();

		virtual DiffWidget * create(const vector<Frame *> & frames);

	protected:
		virtual void draw();	

	private:
		// order is row, column, height
		vector< vector< vector<float> >  >heights;
		vector<QColor> colors;
		Frame * ref;
		float maxHeight;
		int frameCount;
};

#endif // BAR_DIFF_H
