/**
 * This file is part of cs838-dc1
 *
 * cs838-dc1 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 *  cs838-dc1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with cs838-dc1.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Copyright 2010 James Hill
 *   */

#ifndef LIGHTNESS_DIFF_H
#define LIGHTNESS_DIFF_H

#include "diff_widget.h"

#include <QString>

/**
 * a Lightness diff compares two frames by encoding the 
 * linear distance between each entry in the matrix 
 * using a color lightness
 */
class LightnessDiff : public DiffWidget
{
	public:
		LightnessDiff(QWidget * parent = 0);
		virtual ~LightnessDiff();

		virtual DiffWidget * create(const vector<Frame *> & frames);

	protected:
		virtual void draw();	

	private:
		Frame * diff;
		QString title;
};

#endif // LIGHTNESS_DIFF_H
