/**
 * This file is part of cs838-dc1
 *
 * cs838-dc1 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 *  cs838-dc1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with cs838-dc1.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Copyright 2010 James Hill
 *   */

#include "main_widget.h"
#include "distance.h"
#include "GeneralException.h"


#include <vector>
#include <iostream>
using namespace std;

#include <QApplication>

int main(int argc, char** argv)
{
	try
	{
		// register distance functions
		cout << "Registering functions" << endl;
		registerDistanceFunctions();

		// run the widget	
		QApplication app(argc, argv);
		
		MainWidget widget;
		widget.setGeometry(10, 10, 800, 500);
		widget.showMaximized();
		widget.show();

		return app.exec();
	}
	catch(GeneralException & e)
	{
		cout << e.what() << endl;
	}	

	return 0;
}
